function array=disp_patches_norm_central(A,m,buf,norm,valor,norm_global)

% DISP_PATCHES displays the image basis functions at the columns of matrix A
%
% array=disp_patches_norm_central(A,m,buf,norm,extreme_values,norm_global)
%
%  Usage:
%   A = basis function matrix
%   m = number of rows (of the image blocks)
%   buf = space between patches
%   norm = 0 no normalization is applied 
%        = 1 each image is normalized according to the extreme (max or min) of the input images 
%   extreme_values = typically min and max: the first value will be given to the space between images and the second will be the maximum of the colormap
%   norm_global = 1 [once built the array] puts the minimum of the array to zero and the maximum to 1
%               = 0 does nothing (leaves the extremes as they are)  

[L M]=size(A);

sz=sqrt(L);

% buf=1;

if ~exist('norm_global'),
    norm_global = 0;
end

if ~exist('m','var'),
    if floor(sqrt(M))^2 ~= M
        m=floor(sqrt(M/2));
        n=M/m;
    else
        m=sqrt(M);
        n=m;
    end
else
    n=M/m;
end

array = valor(1)*ones(buf+m*(sz+buf),buf+n*(sz+buf));

k=1;

% for i=1:m
%   for j=1:n
%     if norm==1
%     clim=max(abs(A(:,k)));
%     array(buf+(i-1)*(sz+buf)+[1:sz],buf+(j-1)*(sz+buf)+[1:sz])=...
% 	reshape(A(:,k),sz,sz)/clim;
%     else
%     array(buf+(i-1)*(sz+buf)+[1:sz],buf+(j-1)*(sz+buf)+[1:sz])=...
% 	reshape(A(:,k),sz,sz);
%     end
%     k=k+1;
%   end
% end

for i=1:m
  for j=1:n
    ima = reshape(A(:,k),sz,sz);
    ima1 = ima(1:sz/2,1:sz/2);
    ima2 = ima(1:sz/2,sz/2+1:end);
    ima3 = ima(sz/2+1:end,1:sz/2);
    ima4 = ima(sz/2+1:end,sz/2+1:end);
    
    medio = round(sz/4);
    cuarto = round(sz/8);
    
    ima_c1 = ima1(medio-cuarto:medio+cuarto,medio-cuarto:medio+cuarto);
    ima_c2 = ima2(medio-cuarto:medio+cuarto,medio-cuarto:medio+cuarto);
    ima_c3 = ima3(medio-cuarto:medio+cuarto,medio-cuarto:medio+cuarto);
    ima_c4 = ima4(medio-cuarto:medio+cuarto,medio-cuarto:medio+cuarto);
    ima1 = imresize(ima_c1,[sz/2 sz/2]);
    ima2 = imresize(ima_c2,[sz/2 sz/2]);
    ima3 = imresize(ima_c3,[sz/2 sz/2]);
    ima4 = imresize(ima_c4,[sz/2 sz/2]);

    ima = [ima1 ima2;ima3 ima4];
    
    ima = ima(:);
    if norm==1
    clim=max(abs(ima));
    array(buf+(i-1)*(sz+buf)+[1:sz],buf+(j-1)*(sz+buf)+[1:sz])=...
	reshape(ima,sz,sz)/clim;
    else
    array(buf+(i-1)*(sz+buf)+[1:sz],buf+(j-1)*(sz+buf)+[1:sz])=...
	reshape(ima,sz,sz);
    end
    k=k+1;
  end
end

if norm_global ==1
   %m = min(array(:));
   %M = max(array(:));
   m = valor(1);
   M = valor(2);
   array = (array-m)/(M-m);
end

% imagesc(array,'EraseMode','none',[-1 1]);
% axis image off
% drawnow
