function y = dct3(x)

% DCT3 computes the 3D Discrete Cosine Transform of a 3D array
%
% SYNTAX: y = dct3(x)
%
%    x = 3D array of arbitrary size, m*n*k
%    y = 3D DCT of x (it is also a m*n*k 3D array)
% 
% NOTE: inverse is computed by idct3
%

s = size(x);
y = x;

if length(s)==3
    
    for i = 1:s(3)
        y(:,:,i)=dct2(x(:,:,i));
    end
    
    for i=1:s(1)
        for j=1:s(2)
            y(i,j,:) = dct(y(i,j,:));
        end
    end
    
else
    disp(' ')
    disp('Warning! your input is not 3D: nothing was done!')
end