%%
%% A MOVIE AND ITS Spatio-temporal DCT 
%%

%% Movie
load real_seq_Nx_75_Nf_64.mat

s = size(Y);
Y_3d = then2now(Y,s(1));

implay(Y_3d/max(Y_3d(:)))

%% DCT
dctY = dct3(Y_3d);

fsx=37.5;
fsy=fsx;
fst=24;
show_dct3( abs(dctY).^0.25, fsx, fsy, fst, 10000);

%% Inverse
YY = idct3(dctY);

implay(YY/max(YY(:)))

%%
%% DELTA IN THE DCT DOMAIN
%%

num_rows = 75;
num_cols = 75;
num_frames = 64;
[x,y,t,fx,fy,ft] = spatio_temp_DCT_domain(num_rows,num_cols,num_frames,fsx,fsy,fst);

% Look for specific frequency
fx0 = 3;
fy0 = 0;
ft0 = 8;

mx=min(abs(fx(:)-fx0));
px=find(abs(fx(:)-fx0)==mx);
my=min(abs(fy(:)-fy0));
py=find(abs(fy(:)-fy0)==my);
mt=min(abs(ft(:)-ft0));
pt=find(abs(ft(:)-ft0)==mt);

pxy = intersect(px,py);
pxyt = intersect(pt,pxy);

% Generate delta in that frequency
delta = zeros(num_rows,num_cols*num_frames);
delta = delta(:);
delta(pxyt)=1;

delta = reshape(delta,[num_rows num_cols*num_frames]);
delta = then2now(delta,num_cols);

show_dct3( delta , fsx, fsy, fst, 10001);

% Compute the inverse dct3

Func_base = idct3(delta);
m = min(Func_base(:));
M = max(Func_base(:));

implay((Func_base-m)/(M-m));


