%
% EXAMPLE FOR VSITALAB WEB SITE: noise sequence and 3D short-time Fourier transform
%


% Generate 4 sequences of different texture and speed

nx = 64;
nf = 24;
fsx = 64;
fst = 24;
fm = [2  3  6   12 12 12 12];
fM = [3  6  12  24 24 24 24];
angul_wdth = 179.5;
orient = 0;
vy = [0.1 0.15 0.3 0.5 0.3 0.15 0.1];
vx = [0 0 0 0 0 0 0 0],
interpol = 1;

[s1,v_true] = noise_sequence(nx,nf,fsx,fst,fm(1),fM(1),angul_wdth,orient,[vy(1) vx(1)],interpol);
[s2,v_true] = noise_sequence(nx,nf,fsx,fst,fm(2),fM(2),angul_wdth,orient,[vy(2) vx(2)],interpol);
[s3,v_true] = noise_sequence(nx,nf,fsx,fst,fm(3),fM(3),angul_wdth,orient,[vy(3) vx(3)],interpol);
[s4,v_true] = noise_sequence(nx,nf,fsx,fst,fm(4),fM(4),angul_wdth,orient,[vy(4) vx(4)],interpol);
[s5,v_true] = noise_sequence(nx,nf,fsx,fst,fm(5),fM(5),angul_wdth,orient,[vy(5) vx(5)],interpol);
[s6,v_true] = noise_sequence(nx,nf,fsx,fst,fm(6),fM(6),angul_wdth,orient,[vy(6) vx(6)],interpol);
[s7,v_true] = noise_sequence(nx,nf,fsx,fst,fm(7),fM(7),angul_wdth,orient,[vy(7) vx(7)],interpol);

% Control average luminance and contrast
L = 128;
C = 0.9;
s1 = control_lum_contrast(s1,L,C);
s2 = control_lum_contrast(s2,L,C);
s3 = control_lum_contrast(s3,L,C);
s4 = control_lum_contrast(s4,L,C);
s5 = control_lum_contrast(s5,L,C);
s6 = control_lum_contrast(s6,L,C);
s7 = control_lum_contrast(s7,L,C);

peli = [s1 s2 s3 s4 s5 s6 s7];  % paste "film" (movies are in old 2D formar)

% Compute Fourier transforms (removing average luminance -zero-freq component- for better visualization)
shift = 1;
S1 = fft3( s1-L , shift);
S2 = fft3( s2-L , shift);
S3 = fft3( s3-L , shift);
S4 = fft3( s4-L , shift);
S5 = fft3( s5-L , shift);
S6 = fft3( s6-L , shift);
S7 = fft3( s7-L , shift);

% Save avi file

folder = 'C:\disco_portable\mundo_irreal\rutinas\Software_Katedra\Vistalab\sample_data\'
name = 'proba';
fig=100;
compress=1;
MOV = build_achrom_movie_avi(peli,0,2*L,nx,fig,fst,compress,folder,name);

% Represent Fourier transforms
anguls = [-40 55];
show_fft3( abs(S1).^0.9, fsx, fst, 1),view(anguls),axis square,figure(1),axis([-22 22 -22 22 -12 12]),set(1,'color',[1 1 1])
show_fft3( abs(S2).^0.9, fsx, fst, 2),view(anguls),axis square,figure(2),axis([-22 22 -22 22 -12 12]),set(2,'color',[1 1 1])
show_fft3( abs(S3).^0.7, fsx, fst, 3),view(anguls),axis square,figure(3),axis([-22 22 -22 22 -12 12]),set(3,'color',[1 1 1])
show_fft3( abs(S4).^0.7, fsx, fst, 4),view(anguls),axis square,figure(4),axis([-22 22 -22 22 -12 12]),set(4,'color',[1 1 1])
show_fft3( abs(S5).^0.7, fsx, fst, 5),view(anguls),axis square,figure(5),axis([-22 22 -22 22 -12 12]),set(5,'color',[1 1 1])
show_fft3( abs(S6).^0.7, fsx, fst, 6),view(anguls),axis square,figure(6),axis([-22 22 -22 22 -12 12]),set(6,'color',[1 1 1])
show_fft3( abs(S7).^0.7, fsx, fst, 7),view(anguls),axis square,figure(7),axis([-22 22 -22 22 -12 12]),set(7,'color',[1 1 1])


anguls = [-32 12];
anguls = [-76 4];
show_fft3( abs(S1).^1.5, fsx, fst, 8),view(anguls),axis square,figure(8),axis([-22 22 -22 22 -12 12]),set(8,'color',[1 1 1])
show_fft3( abs(S2).^1.5, fsx, fst, 9),view(anguls),axis square,figure(9),axis([-22 22 -22 22 -12 12]),set(9,'color',[1 1 1])
show_fft3( abs(S3).^0.99, fsx, fst, 10),view(anguls),axis square,figure(10),axis([-22 22 -22 22 -12 12]),set(10,'color',[1 1 1])
show_fft3( abs(S4).^0.99, fsx, fst, 11),view(anguls),axis square,figure(11),axis([-22 22 -22 22 -12 12]),set(11,'color',[1 1 1])
show_fft3( abs(S5).^0.99, fsx, fst, 12),view(anguls),axis square,figure(12),axis([-22 22 -22 22 -12 12]),set(12,'color',[1 1 1])
show_fft3( abs(S6).^0.99, fsx, fst, 13),view(anguls),axis square,figure(13),axis([-22 22 -22 22 -12 12]),set(13,'color',[1 1 1])
show_fft3( abs(S7).^0.99, fsx, fst, 14),view(anguls),axis square,figure(14),axis([-22 22 -22 22 -12 12]),set(14,'color',[1 1 1])

% Play movie

peli3d = then2now(peli,nx);
implay(peli3d/256,fst)


%%%% Cut the Fourier plots by hand

% Paste the Fourier plots to generate a nice movie

fig1 = imread('fig1.JPG');
fig1 = imresize(fig1, [419 537]);
fig1a = imread('fig1a.JPG');
fig1a = imresize(fig1a, [419 355]);
fig1 = cat(2,fig1a,fig1);

fig2 =  imread('fig2.JPG');
fig2 = imresize(fig2, [419 537]);
fig2a = imread('fig2a.JPG');
fig2a =imresize(fig2a, [419 355]);
fig2 =    cat(2,fig2a,fig2);

fig3 =  imread('fig3.JPG');
fig3 = imresize(fig3, [419 537]);
fig3a = imread('fig3a.JPG');
fig3a =imresize(fig3a, [419 355]);
fig3 =    cat(2,fig3a,fig3);

fig4 =  imread('fig4.JPG');
fig4 = imresize(fig4, [419 537]);
fig4a = imread('fig4a.JPG');
fig4a =imresize(fig4a, [419 355]);
fig4 =    cat(2,fig4a,fig4);

fig5 =  imread('fig5.JPG');
fig5 = imresize(fig5, [419 537]);
fig5a = imread('fig5a.JPG');
fig5a =imresize(fig5a, [419 355]);
fig5 =    cat(2,fig5a,fig5);

fig6 =  imread('fig6.JPG');
fig6 = imresize(fig6, [419 537]);
fig6a = imread('fig6a.JPG');
fig6a =imresize(fig6a, [419 355]);
fig6 =    cat(2,fig6a,fig6);

fig7 =  imread('fig7.JPG');
fig7 = imresize(fig7, [419 537]);
fig7a = imread('fig7a.JPG');
fig7a =imresize(fig7a, [419 355]);
fig7 =    cat(2,fig7a,fig7);

transf = zeros(419,892,3,168);

for i=1:168
    n_fot = ceil(7*i/168);
    if n_fot ==1
       imagen = fig1; 
    elseif n_fot ==2
       imagen = fig2; 
    elseif n_fot ==3
       imagen = fig3; 
    elseif n_fot ==4
       imagen = fig4; 
    elseif n_fot ==5
       imagen = fig5; 
    elseif n_fot ==6
       imagen = fig6; 
    else
       imagen = fig7;
    end
       
    transf(:,:,:,i)=imagen; 
end

folder = 'C:\disco_portable\mundo_irreal\rutinas\Software_Katedra\Vistalab\sample_data\'
name = 'probaF';
fig=1;
compress=1;
build_color_avi(transf/255,fig,fst,compress,folder,name);
