function x=idct3(y)

% IDCT3 computes the inverse of the 3D DCT transform (computed by dct3)
%
% SYNTAX: x = idct3(y)
%
%    y = 3D array of arbitrary size, m*n*k, computed by dct3.m
%    x = inverse of 3D DCT (it is also a m*n*k 3D array)
% 

s = size(y);
x = y;

if length(s)==3
    
    for i=1:s(1)
        for j=1:s(2)
            x(i,j,:) = idct(y(i,j,:));
        end
    end
    
    for i = 1:s(3)
        x(:,:,i)=idct2(x(:,:,i));
    end
    
else
    disp(' ')
    disp('Warning! your input is not 3D: nothing was done!')
end