% MOVIMIENTO REAL FRENTE A MOVIMINTO RETINIANO
% MOVIMIENTO CON Y SIN PERCEPCION DE FORMAS
%
% En este script se muestran secuencias que ilustran los conceptos del
% punto 1.1:
%  - Diferencia entre movimiento real (3D) y movimiento retiniano (2D)
%  - Percepcion de movimiento con y sin vision de formas
%
% Las secuencias fueron calculadas mediante
%
%  - peliculas_objeto_movim.m
%  - peliculas_movim_objeto.m
%


% MOVIMIENTO REAL FRENTE A MOVIMIENTO RETINIANO
%
% Estas secuencias corresponden al mismo movimiento real 3D tomadas desde
% diferentes puntos de vista (ver comentarios de peliculas_objeto_movim.m)
%
% Como se puede ver, tanto la irradiancia en el plano imagen como sus
% variaciones (y las velocidades 2D correspondientes)

load pelis_obj_mov

P=hazpeli([peli1;32*ones(10,10000);peli3;32*ones(10,10000);peli5;32*ones(10,10000)],330,100,gray,1);

figure(1),movie(P,-3,20)

peli11=peli1;
peli22=peli2;

% MOVIMIENTO CON VISION DE FORMA FRENTE A MOVIMIENTOS SIN VISION DE FORMAS
%
% En las siguientes figuras se mostrara:
%
%   - Los dos primeros fotogramas de tres secuencias
%     (donde se podra apreciar -o no-, la presencia de un objeto) 
%   - Las secuencias en movimiento
%
% Como se ve, en las secuencias 2 y 3 necesitamos el movimiento para percibir la forma
% (cosa que no es necesaria en la secuencia 1).

load pelis_mov_obj

for fot=15:50
%fot=15;
peli111=sacafot(peli11,100,100,[fot:100]);
peli222=sacafot(peli1,100,100,[fot-10:100-10]);
peli333=sacafot(peli2,100,100,[fot:100]);

im11=sacafot(peli111,100,100,1);
im12=sacafot(peli111,100,100,2);

im21=sacafot(peli222,100,100,1);
im22=sacafot(peli222,100,100,2);

im31=sacafot(peli333,100,100,1);
im32=sacafot(peli333,100,100,2);

figure(2),
subplot(321),colormap(gray),imagesc(im11),axis('off'),axis('square'),title(num2str(fot-15+1)),subplot(322),colormap(gray),imagesc(im12),axis('off'),axis('square'),title(num2str(fot-15+2))
subplot(323),colormap(gray),imagesc(im21),axis('off'),axis('square'),subplot(324),colormap(gray),imagesc(im22),axis('off'),axis('square'),
subplot(325),colormap(gray),imagesc(im31),axis('off'),axis('square'),subplot(326),colormap(gray),imagesc(im32),axis('off'),axis('square'),

pause
end

m=size(peli111);
P=hazpeli([peli111;32*ones(10,m(2));peli222;32*ones(10,m(2));peli333;32*ones(10,m(2))],330,100,gray,3);

movie(P,-3,20)