% PRIMERO MOVIMIENTO, LUEGO OBJETO
%
% En este script se generan dos secuencias (con fotogramas de ruido blanco)
% en la que se percibe la forma del objeto partiendo del movimiento que
% tiene (se percibe primero el movimiento y de ahi se deduce la forma del
% objeto).
%
% Generamos dos tipos de secuencias: 
%
%   Secuencia 1:
%
%     Un cuadrado (de ruido uniforme y blanco) de tamao y posicion inicial dados, 
%     que se mueve con velocidad v sobre un fondo estatico de ruido blanco
%     (la peli es relativamente cutre porque se hacen desplazamientos con
%     precision de pixel)
%
%     La forma del movil es indistinguible (en un solo fotograma) porque se
%     confunde con el fondo)
%
%   Secuencia 2
%
%     En un fondo estatico de ruido blanco se hace un agujero (con una
%     cierta forma... cuadrado, circular, eliptico) y atraves de dicho
%     agujero se ve una secuencia de ruido blanco en movimiento con
%     velocidad v.
%     En este caso los desplazamientos si tienen precision sub-pixel y
%     entonces el movimiento es mas suave
%
%     La forma del movil es indistinguible (en un solo fotograma) porque se
%     confunde con el fondo)

% SECUENCIA 1

p_inicial=[20 50];
tam=[30 30];
Npix=100;
Nfot=100;
fsx=37.5;
fst=25;
v=0.65*[1 0];  % veloc [vy vx]

[peli1,v_real]=cuadro_ruido_v(p_inicial,tam,Npix,Nfot,fsx,fst,v,1);

peli1=64*peli1/maxi(peli1);

% SECUENCIA 2

Npix=100;
Nfot=100;
fsx=37.5;
fst=25;
v=0.65*[-1 0];  % veloc [vy vx]

% Mascara (objeto)

pos=[0.5 0.5]; % Tamao respecto de lado unidad
r=0.25;

[x,y]=meshgrid(linspace(0,1,Npix),linspace(0,1,Npix));
objeto=((x-pos(1)).^2+(y-pos(2)).^2)<r.^2;
fondo=objeto==0;

%[s1,v_real]=ruidov2(Npix,Nfot,fsx,fst,0,fsx/2,179.9,0,[0 0],1);
[s2,v_real]=ruidov2(Npix,Nfot,fsx,fst,0,fsx/2,179.9,0,v,1);

peli2=s2;

for i=1:Nfot;
    im1=sacafot(s2,Npix,Npix,2);
    im2=sacafot(s2,Npix,Npix,i);
    im=double(objeto).*im2+double(fondo).*im1;
    peli2=metefot(peli2,im,i,1);
end
peli2=64*peli2/maxi(peli2);